diff --git a/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorTerrainImpl.java b/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorTerrainImpl.java
index fab038112..2c72be94e 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorTerrainImpl.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorTerrainImpl.java
@@ -1,254 +1,329 @@
 package net.minecraft.client.render.tessellator;
 
-import java.nio.ByteBuffer;
-
-import com.mojang.logging.LogUtils;
-import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.renderer.DrawMode;
 import net.minecraft.client.render.terrain.VertexConfig;
 import net.minecraft.client.render.terrain.VertexData;
+import net.minecraft.core.util.helper.Color;
+import net.minecraft.core.util.helper.MathHelper;
 import org.jetbrains.annotations.NotNull;
-import org.lwjgl.BufferUtils;
 import org.lwjgl.opengl.GL41;
-import org.slf4j.Logger;
+
+import java.nio.ByteBuffer;
 
 public class TessellatorTerrainImpl implements TessellatorGeneral {
-	private static final Logger LOGGER = LogUtils.getLogger();
-	public TerrainVertexData data;
-	public boolean drawing;
-
-	private int color;
-	private int lightmapCoord;
-	
-	private double textureU;
-	private double textureV;
-	
-	private double offsetX;
-	private double offsetY;
-	private double offsetZ;
-
-	private byte normalX;
-	private byte normalY;
-	private byte normalZ;
-
-	private boolean lockedColor = false;
-	private int quadVertCount = 0;
-	
-	public TessellatorTerrainImpl(int bufferSize) {
+    private final float[] quadPoses = new float[3 * 4];
+    private final float[] quadUVs = new float[2 * 4];
+    private final byte[] quadNormals = new byte[3 * 4];
+    private final byte[] quadLightMap = new byte[4];
+    private final byte[] quadShade = new byte[4];
+    private final int[] quadColors = new int[4];
+
+
+    public final @NotNull TerrainVertexData data;
+
+    public boolean drawing;
+
+    private int color;
+    private byte lightIndex;
+    private byte shade = (byte) 0xFF;
+
+    private double textureU;
+    private double textureV;
+
+    private double offsetX;
+    private double offsetY;
+    private double offsetZ;
+
+    private byte normalX;
+    private byte normalY;
+    private byte normalZ;
+
+    private boolean lockedColor = false;
+    private int quadVertCount = 0;
+
+    public TessellatorTerrainImpl(final int bufferSize) {
         this.data = new TerrainVertexData(bufferSize);
-	}
-	
-	@Override
-	public void startDrawing(@NotNull DrawMode drawMode) {
-		if(this.drawing) {
-			this.drawing = false;
-			throw new IllegalStateException("Already drawing!");
-		}
-
-		this.drawing = true;
+    }
+
+    @Override
+    public void startDrawing(final @NotNull DrawMode drawMode) {
+        if (this.drawing) {
+            this.drawing = false;
+            throw new IllegalStateException("Already drawing!");
+        }
+
+        this.drawing = true;
         this.data.vertexCount = 0;
-		this.quadVertCount = 0;
+        this.quadVertCount = 0;
+
+        this.setLightmapCoord2i(15, 15);
+        this.setColor4i(255, 255, 255, 255);
+        this.setTextureUV(0.0, 0.0);
+        this.setNormal(0, 1, 0);
+
+        this.lockedColor = false;
+        this.data.getBuffer().clear();
+    }
+
+    @Override
+    public void draw() {
+        throw new UnsupportedOperationException();
+    }
+
+    @Override
+    public @NotNull RenderBuffer record(final int vao, final int vbo) {
+        throw new UnsupportedOperationException();
+    }
+
+    @Override
+    public void addVertex(final double x, final double y, final double z) {
+        this.checkIsDrawing();
+
+        int index = this.quadVertCount % 4;
+        this.quadPoses[index * 3] = (float) (this.offsetX + x);
+        this.quadPoses[index * 3 + 1] = (float) (this.offsetY + y);
+        this.quadPoses[index * 3 + 2] = (float) (this.offsetZ + z);
+
+        this.quadColors[index] = this.color;
+
+        this.quadUVs[index * 2] = (float) this.textureU;
+        this.quadUVs[index * 2 + 1] = (float) this.textureV;
+
+        this.quadLightMap[index] = this.lightIndex;
+        this.quadShade[index] = this.shade;
+
+        this.quadNormals[index * 3] = this.normalX;
+        this.quadNormals[index * 3 + 1] = this.normalY;
+        this.quadNormals[index * 3 + 2] = this.normalZ;
+
+        this.quadVertCount++;
+
+        if (index == 3) { // Emit compressed quad
+            this.data.resizeIfNeeded(128);
+            ByteBuffer buffer = this.data.getBuffer();
+
+            float spX = this.quadPoses[0];
+            float spY = this.quadPoses[1];
+            float spZ = this.quadPoses[2];
+
+            // Average normals for quad
+            byte nX = (byte) ((this.quadNormals[0] + this.quadNormals[3] + this.quadNormals[6] + this.quadNormals[9])/4);
+            byte nY = (byte) ((this.quadNormals[1] + this.quadNormals[4] + this.quadNormals[7] + this.quadNormals[10])/4);
+            byte nZ = (byte) ((this.quadNormals[2] + this.quadNormals[5] + this.quadNormals[8] + this.quadNormals[11])/4);
 
-		setLightmapCoord1i(LightmapHelper.getLightmapCoord(15, 15));
-		setColor4i(255, 255, 255, 255);
-		setTextureUV(0.0, 0.0);
-		setNormal(0, 1, 0);
+            int color = this.quadColors[0];
 
-		this.lockedColor = false;
-        this.data.buffer.clear();
-	}
-
-	@Override
-	public void draw() {
-		throw new UnsupportedOperationException();
-	}
-
-	@Override
-	public @NotNull RenderBuffer record(int vao, int vbo) {
-		throw new UnsupportedOperationException();
-	}
-
-	@Override
-	public void addVertex(double x, double y, double z) {
-		checkIsDrawing();
-		checkCanFit(64);
-		
-		ByteBuffer buffer = this.data.buffer;
-		
-		buffer.putFloat((float) (this.offsetX + x));
-		buffer.putFloat((float) (this.offsetY + y));
-		buffer.putFloat((float) (this.offsetZ + z));
-
-        buffer.putInt(this.color);
-
-        buffer.putFloat((float) this.textureU);
-        buffer.putFloat((float) this.textureV);
-
-		buffer
-			.put((byte) ((LightmapHelper.getBlockLightFromCoord(this.lightmapCoord) << 4) + 7))
-			.put((byte) ((LightmapHelper.getSkyLightFromCoord(this.lightmapCoord) << 4) + 7));
-
-		buffer.put(this.normalX);
-		buffer.put(this.normalY);
-		buffer.put(this.normalZ);
-
-
-
-        this.data.vertexCount++;
-
-		if (Tessellator.QUAD_EMULATION && this.quadVertCount % 4 == 2) {
-			int vertSize = this.data.config.getVertexSize();
-
-			checkCanFit(128);
-			this.data.buffer.put(this.data.buffer.position(), this.data.buffer, this.data.buffer.position() - vertSize * 3, vertSize);
-			this.data.buffer.put(this.data.buffer.position() + vertSize, this.data.buffer, this.data.buffer.position() - vertSize, vertSize);
-			this.data.buffer.position(this.data.buffer.position() + vertSize * 2);
-			this.data.vertexCount += 2;
-		}
-
-		this.quadVertCount++;
-	}
-
-	public void checkCanFit(int size) {
-		if(this.data.buffer.capacity() < this.data.buffer.position() + size) {
-			int newSize = this.data.buffer.capacity() * 2;
-
-			LOGGER.info("Expanding {} Buffer ({} -> {})", "Terrain Tessellator", this.data.buffer.capacity(), newSize);
-
-			ByteBuffer newBuffer = BufferUtils.createByteBuffer(newSize);
-			this.data.buffer.flip();
-			newBuffer.put(this.data.buffer);
-			this.data.buffer = newBuffer;
-		}
-	}
-
-	@Override
-	public void setTextureUV(double u, double v) {
-		checkIsDrawing();
-
-		this.textureU = u;
-		this.textureV = v;
-	}
-
-	@Override
-	public void setLightmapCoord1i(int lightmapCoord) {
-		checkIsDrawing();
-
-		this.lightmapCoord = lightmapCoord;
-	}
-
-	@Override
-	public void setColor1i(int argb) {
-		checkIsDrawing();
-		if (this.lockedColor) {
-			return;
-		}
-
-		int a = (argb >> 24) & 0xFF;
-		int r = (argb >> 16) & 0xFF;
-		int g = (argb >> 8) & 0xFF;
-		int b = argb & 0xFF;
-
-		this.color = a << 24 | b << 16 | g << 8 | r;
-	}
-
-	@Override
-	public void lockColor() {
-		checkIsDrawing();
-		
-		this.lockedColor = true;
-	}
-
-	@Override
-	public void setTranslation(double x, double y, double z) {
-		this.offsetX = x;
-		this.offsetY = y;
-		this.offsetZ = z;
-	}
-
-	@Override
-	public void offsetTranslation(double x, double y, double z) {
-		this.offsetX += x;
-		this.offsetY += y;
-		this.offsetZ += z;
-	}
-
-	public void checkIsDrawing() {
-		if(!this.drawing) {
-			this.drawing = false;
-			throw new IllegalStateException("Not drawing!");
-		}
-	}
-
-	@Override
-	public void setNormal(float x, float y, float z) {
-		checkIsDrawing();
-
-		this.normalX = (byte) (x * 127.0f);
-		this.normalY = (byte) (y * 127.0f);
-		this.normalZ = (byte) (z * 127.0f);
-	}
-
-	public static class TerrainVertexData extends VertexData {
-
-		public TerrainVertexData(int size) {
-			super(size);
-			this.config = new TerrainVertexConfig();
-		}
-	}
-
-	public static class TerrainVertexConfig implements VertexConfig<TerrainVertexConfig> {
-
-		@Override
-		public @NotNull DrawMode drawmode() {
-			return Tessellator.QUAD_EMULATION ? DrawMode.TRIANGLES : DrawMode.QUADS;
-		}
-
-		public void enable(int vao, int vbo) {
-			GL41.glBindVertexArray(vao);
-			GL41.glBindBuffer(GL41.GL_ARRAY_BUFFER, vbo);
-
-			int vertexSize = getVertexSize();
-			int offset = 0;
-			GL41.glVertexAttribPointer(0, 3, GL41.GL_FLOAT, false, vertexSize, offset); offset += 3 * Float.BYTES;    // Pos
-            GL41.glVertexAttribPointer(1, 4, GL41.GL_UNSIGNED_BYTE, true, vertexSize, offset); offset += 4;    // Color
-			GL41.glVertexAttribPointer(2, 2, GL41.GL_FLOAT, false, vertexSize, offset); offset += 2 * Float.BYTES;    // UV
-			GL41.glVertexAttribPointer(3, 2, GL41.GL_UNSIGNED_BYTE, true, vertexSize, offset); offset += 2;    // Lightmap
-			GL41.glVertexAttribPointer(4, 3, GL41.GL_BYTE, true, vertexSize, offset); offset += 3;    // Normals
-
-			GL41.glEnableVertexAttribArray(0);
-			GL41.glEnableVertexAttribArray(1);
-			GL41.glEnableVertexAttribArray(2);
-			GL41.glEnableVertexAttribArray(3);
-			GL41.glEnableVertexAttribArray(4);
-		}
-
-		public void disable() {
-			GL41.glDisableVertexAttribArray(0);
-			GL41.glDisableVertexAttribArray(1);
-			GL41.glDisableVertexAttribArray(2);
-			GL41.glDisableVertexAttribArray(3);
-
-			GL41.glBindBuffer(GL41.GL_ARRAY_BUFFER, 0);
-			GL41.glBindVertexArray(0);
-		}
-
-		public int getVertexSize() {
-			int size = Float.BYTES * 3;
-            size += 4;
-            size += Float.BYTES * 2;
-            size += 2;
-            size += 3;
-			return size;
-		}
-
-		public @NotNull TerrainVertexConfig copy() {
+            buffer.putFloat(spX).putFloat(spY).putFloat(spZ);
+            buffer.put((byte) Color.blueFromInt(color)).put((byte) Color.greenFromInt(color)).put((byte) Color.redFromInt(color));
+            buffer.put(nX).put(nY).put(nZ);
+
+            buffer.putShort((short) (this.quadUVs[0] * 0xFFFF)).putShort((short) (this.quadUVs[1] * 0xFFFF));
+            buffer.put(this.quadShade[0]).put(this.quadLightMap[0]);
+
+            buffer.putShort(MathHelper.toHalfFloat(this.quadPoses[3] - spX)).putShort(MathHelper.toHalfFloat(this.quadPoses[4] - spY)).putShort(MathHelper.toHalfFloat(this.quadPoses[5] - spZ));
+            buffer.putShort((short) (this.quadUVs[2] * 0xFFFF)).putShort((short) (this.quadUVs[3] * 0xFFFF));
+            buffer.put(this.quadShade[1]).put(this.quadLightMap[1]);
+
+            buffer.putShort(MathHelper.toHalfFloat(this.quadPoses[6] - spX)).putShort(MathHelper.toHalfFloat(this.quadPoses[7] - spY)).putShort(MathHelper.toHalfFloat(this.quadPoses[8] - spZ));
+            buffer.putShort((short) (this.quadUVs[4] * 0xFFFF)).putShort((short) (this.quadUVs[5] * 0xFFFF));
+            buffer.put(this.quadShade[2]).put(this.quadLightMap[2]);
+
+            buffer.putShort(MathHelper.toHalfFloat(this.quadPoses[9] - spX)).putShort(MathHelper.toHalfFloat(this.quadPoses[10] - spY)).putShort(MathHelper.toHalfFloat(this.quadPoses[11] - spZ));
+            buffer.putShort((short) (this.quadUVs[6] * 0xFFFF)).putShort((short) (this.quadUVs[7] * 0xFFFF));
+            buffer.put(this.quadShade[3]).put(this.quadLightMap[3]);
+
+            this.data.vertexCount++;
+        }
+    }
+
+    @Override
+    public void setTextureUV(final double u, final double v) {
+        this.checkIsDrawing();
+
+        this.textureU = u;
+        this.textureV = v;
+    }
+
+    @Override
+    public void setLightmapCoord1i(final int lightIndex) {
+        this.checkIsDrawing();
+
+        this.lightIndex = (byte) lightIndex;
+    }
+
+    @Override
+    public void setColor1i(final int argb) {
+        this.checkIsDrawing();
+        if (this.lockedColor) {
+            return;
+        }
+
+        final int a = (argb >> 24) & 0xFF;
+        final int r = (argb >> 16) & 0xFF;
+        final int g = (argb >> 8) & 0xFF;
+        final int b = argb & 0xFF;
+
+        this.color = a << 24 | b << 16 | g << 8 | r;
+    }
+
+    @Override
+    public void lockColor() {
+        this.checkIsDrawing();
+
+        this.lockedColor = true;
+    }
+
+    @Override
+    public void setTranslation(final double x, final double y, final double z) {
+        this.offsetX = x;
+        this.offsetY = y;
+        this.offsetZ = z;
+    }
+
+    @Override
+    public void offsetTranslation(final double x, final double y, final double z) {
+        this.offsetX += x;
+        this.offsetY += y;
+        this.offsetZ += z;
+    }
+
+    private void checkIsDrawing() {
+        if (!this.drawing) {
+            throw new IllegalStateException("Not drawing!");
+        }
+    }
+
+    @Override
+    public void setNormal(final float x, final float y, final float z) {
+        this.checkIsDrawing();
+
+        this.normalX = (byte) (x * 127.0f);
+        this.normalY = (byte) (y * 127.0f);
+        this.normalZ = (byte) (z * 127.0f);
+    }
+
+    private int getUncompressVertexSize() {
+        int size = 0;
+        size += Float.BYTES * 3;
+        size += Byte.BYTES * 4;
+        size += Float.BYTES * 2;
+        size += Byte.BYTES;
+        size += Byte.BYTES * 3;
+        return size;
+    }
+
+    @Override
+    public void setShade1i(int shade) {
+        this.checkIsDrawing();
+        this.shade = (byte) shade;
+    }
+
+    public static class TerrainVertexData extends VertexData<TerrainVertexConfig> {
+
+        public TerrainVertexData(final int size) {
+            super(new TerrainVertexConfig(), size);
+        }
+    }
+
+    public static class TerrainVertexConfig implements VertexConfig<TerrainVertexConfig> {
+        @Override
+        public @NotNull DrawMode drawMode() {
+            return DrawMode.POINTS;
+        }
+
+        public void enable(final int vao, final int vbo) {
+            GL41.glBindVertexArray(vao);
+            GL41.glBindBuffer(GL41.GL_ARRAY_BUFFER, vbo);
+
+            final int vertexSize = this.getVertexSize();
+            int offset = 0;
+            GL41.glVertexAttribPointer(0, 3, GL41.GL_FLOAT, false, vertexSize, offset); offset += 3 * Float.BYTES; // Source Pos
+            GL41.glVertexAttribPointer(1, 3, GL41.GL_UNSIGNED_BYTE, true, vertexSize, offset); offset += 3; // Source Color
+            GL41.glVertexAttribPointer(2, 3, GL41.GL_BYTE, true, vertexSize, offset); offset += 3; // Source Normal
+
+            GL41.glVertexAttribPointer(3, 2, GL41.GL_UNSIGNED_SHORT, true, vertexSize, offset); offset += 2 * Short.BYTES; // V1 UV
+            GL41.glVertexAttribPointer(4, 2, GL41.GL_UNSIGNED_BYTE, false, vertexSize, offset); offset += 2; // V1 LightShade
+
+            GL41.glVertexAttribPointer(5, 3, GL41.GL_HALF_FLOAT, false, vertexSize, offset); offset += 3 * (Float.BYTES/2); // V2 Pos Offset
+            GL41.glVertexAttribPointer(6, 2, GL41.GL_UNSIGNED_SHORT, true, vertexSize, offset); offset += 2 * Short.BYTES; // V2 UV
+            GL41.glVertexAttribPointer(7, 2, GL41.GL_UNSIGNED_BYTE, false, vertexSize, offset); offset += 2; // V2 LightShade
+
+            GL41.glVertexAttribPointer(8, 3, GL41.GL_HALF_FLOAT, false, vertexSize, offset); offset += 3 * (Float.BYTES/2); // V3 Pos Offset
+            GL41.glVertexAttribPointer(9, 2, GL41.GL_UNSIGNED_SHORT, true, vertexSize, offset); offset += 2 * Short.BYTES; // V3 UV
+            GL41.glVertexAttribPointer(10, 2, GL41.GL_UNSIGNED_BYTE, false, vertexSize, offset); offset += 2; // V3 LightShade
+
+            GL41.glVertexAttribPointer(11, 3, GL41.GL_HALF_FLOAT, false, vertexSize, offset); offset += 3 * (Float.BYTES/2); // V4 Pos Offset
+            GL41.glVertexAttribPointer(12, 2, GL41.GL_UNSIGNED_SHORT, true, vertexSize, offset); offset += 2 * Short.BYTES; // V4 UV
+            GL41.glVertexAttribPointer(13, 2, GL41.GL_UNSIGNED_BYTE, false, vertexSize, offset); offset += 2; // V4 LightShade
+
+            assert  offset == vertexSize;
+
+            GL41.glEnableVertexAttribArray(0);
+            GL41.glEnableVertexAttribArray(1);
+            GL41.glEnableVertexAttribArray(2);
+            GL41.glEnableVertexAttribArray(3);
+            GL41.glEnableVertexAttribArray(4);
+            GL41.glEnableVertexAttribArray(5);
+            GL41.glEnableVertexAttribArray(6);
+            GL41.glEnableVertexAttribArray(7);
+            GL41.glEnableVertexAttribArray(8);
+            GL41.glEnableVertexAttribArray(9);
+            GL41.glEnableVertexAttribArray(10);
+            GL41.glEnableVertexAttribArray(11);
+            GL41.glEnableVertexAttribArray(12);
+            GL41.glEnableVertexAttribArray(13);
+        }
+
+        public void disable() {
+            GL41.glDisableVertexAttribArray(0);
+            GL41.glDisableVertexAttribArray(1);
+            GL41.glDisableVertexAttribArray(2);
+            GL41.glDisableVertexAttribArray(3);
+            GL41.glDisableVertexAttribArray(4);
+            GL41.glDisableVertexAttribArray(5);
+            GL41.glDisableVertexAttribArray(6);
+            GL41.glDisableVertexAttribArray(7);
+            GL41.glDisableVertexAttribArray(8);
+            GL41.glDisableVertexAttribArray(9);
+            GL41.glDisableVertexAttribArray(10);
+            GL41.glDisableVertexAttribArray(11);
+            GL41.glDisableVertexAttribArray(12);
+            GL41.glDisableVertexAttribArray(13);
+
+            GL41.glBindBuffer(GL41.GL_ARRAY_BUFFER, 0);
+            GL41.glBindVertexArray(0);
+        }
+
+        public int getVertexSize() {
+            int size = 0;
+            size += 3 * Float.BYTES; // Source Pos
+            size += 3; // Source Color
+            size += 3; // Source Normal
+
+            size += 2 * Short.BYTES; // V1 UV
+            size += 2; // V1 LightShade
+
+            size += 3 * (Float.BYTES/2); // V2 Pos Offset
+            size += 2 * Short.BYTES; // V2 UV
+            size += 2; // V2 LightShade
+
+            size += 3 * (Float.BYTES/2); // V3 Pos Offset
+            size += 2 * Short.BYTES; // V3 UV
+            size += 2; // V3 LightShade
+
+            size += 3 * (Float.BYTES/2); // V4 Pos Offset
+            size += 2 * Short.BYTES; // V4 UV
+            size += 2; // V4 LightShade
+            return size;
+        }
+
+        public @NotNull TerrainVertexConfig copy() {
             return this;
-		}
+        }
 
-		@Override
-		public boolean equals(Object obj) {
+        @Override
+        public boolean equals(final Object obj) {
             return obj instanceof TerrainVertexConfig;
         }
-	}
+    }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/texture/stitcher/TextureRegistry.java b/game/client/src/main/java/net/minecraft/client/render/texture/stitcher/TextureRegistry.java
index 5092ad179..10419191d 100644
--- a/game/client/src/main/java/net/minecraft/client/render/texture/stitcher/TextureRegistry.java
+++ b/game/client/src/main/java/net/minecraft/client/render/texture/stitcher/TextureRegistry.java
@@ -57,7 +57,7 @@ public class TextureRegistry {
             .addDirectory("block", "textures/block")
             .addDirectory("item", "textures/item")
             .addDirectory("particle", "textures/particle")
-//            .addLayer("maskColor", "cmask", 0xFFFFFFFF)
+            .addLayer("maskColor", "cmask", 0xFFFFFFFF)
             .addLayer("emissive", "emiss", 0x00000000)
     );
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMeshGold.java b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMeshGold.java
index 842d66d02..58c4fea60 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMeshGold.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMeshGold.java
@@ -25,7 +25,7 @@ public class TileEntityRendererMeshGold extends TileEntityRenderer<TileEntityMes
 
         ItemModelDispatcher.getInstance().getDispatch(tileEntity.filterItem).renderItemEntity(tessellator, tileEntity.filterItem,
             GameSettings.ITEMS_3D.value, 1, tileEntity.ticksRan, yaw,
-            Minecraft.getMinecraft().currentWorld.getLightmapCoord(new TilePos(tileEntity.x, tileEntity.y, tileEntity.z), 0), renderPartialTicks);
+            Minecraft.getMinecraft().currentWorld.getLightIndex(new TilePos(tileEntity.x, tileEntity.y, tileEntity.z), 0), renderPartialTicks);
         GLRenderer.popFrame();
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
index 73fac9b52..a6787c30d 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
@@ -5,7 +5,6 @@ import it.unimi.dsi.fastutil.ints.IntList;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.option.enums.TextOutlineQuality;
-import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.camera.ICamera;
 import net.minecraft.client.render.font.FontRenderer;
 import net.minecraft.client.render.font.SF;
@@ -113,7 +112,7 @@ public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign> {
         float lightOffset = 0f;
         if (tileEntity.isGlowing()) {
             lightOffset = 96f;
-            GLRenderer.setLightmapCoord1i(LightmapHelper.getLightmapCoord(15, 15));
+            GLRenderer.setLightmapCoord2i(15, 15);
         }
 
         GLRenderer.pushFrame();
diff --git a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererStatue.java b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererStatue.java
index 79374338e..acddbcc65 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererStatue.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererStatue.java
@@ -75,21 +75,21 @@ public class TileEntityRendererStatue extends TileEntityRenderer<TileEntityStatu
                 renderArmor(tessellator, armorWearer, i, pose);
             }
         }
-        renderHeldItem(heldStack, Minecraft.getMinecraft().currentWorld.getLightmapCoord(new TilePos(statue.x, statue.y, statue.z), 0), isPigman);
+        renderHeldItem(heldStack, Minecraft.getMinecraft().currentWorld.getLightIndex(new TilePos(statue.x, statue.y, statue.z), 0), isPigman);
         GLRenderer.popFrame();
 
         GLRenderer.enableState(State.CULL_FACE);
         GLRenderer.popFrame();
     }
 
-    private void renderHeldItem(final @Nullable ItemStack itemStack, int lightmap, final boolean isPigman) {
+    private void renderHeldItem(final @Nullable ItemStack itemStack, byte lightIndex, final boolean isPigman) {
         if (itemStack != null) {
             GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, 1.0F);
             model(isPigman).translateToBone("rightItem");
             GLRenderer.modelM4f().scale(-1, 1, 1);
             GLRenderer.modelM4f().scale(ENTITY_RENDER_SCALE, ENTITY_RENDER_SCALE, ENTITY_RENDER_SCALE);
             ItemModelDispatcher.getInstance().getDispatch(itemStack).render(GLRenderer.getTessellator(), null, itemStack, DisplayPos.THIRD_PERSON_RIGHT_HAND, true, 1,
-               lightmap, 1f, false);
+                lightIndex, 1f, false);
             GLRenderer.enableState(State.CULL_FACE);
         }
     }
diff --git a/game/client/src/main/java/net/minecraft/client/world/WorldClient.java b/game/client/src/main/java/net/minecraft/client/world/WorldClient.java
index bdf321612..b61b6d726 100644
--- a/game/client/src/main/java/net/minecraft/client/world/WorldClient.java
+++ b/game/client/src/main/java/net/minecraft/client/world/WorldClient.java
@@ -156,11 +156,6 @@ public class WorldClient extends World {
         return new Vector3f(r, g, b);
     }
 
-    @Override
-    public int getLightmapCoord(int skyLight, int blockLight) {
-        return LightmapHelper.getLightmapCoord(skyLight, blockLight);
-    }
-
     @Override
     public int renderDistance() {
         return GameSettings.RENDER_DISTANCE.value;
diff --git a/game/client/src/main/java/org/useless/dragonfly/models/block/StaticBlockModel.java b/game/client/src/main/java/org/useless/dragonfly/models/block/StaticBlockModel.java
index 3186374da..b51a0106c 100644
--- a/game/client/src/main/java/org/useless/dragonfly/models/block/StaticBlockModel.java
+++ b/game/client/src/main/java/org/useless/dragonfly/models/block/StaticBlockModel.java
@@ -17,7 +17,7 @@ public interface StaticBlockModel {
     /**
      * @return True if anything rendered, false otherwise
      */
-    boolean renderStandalone(@NotNull BlockModelGeneric<? extends BlockLogic> sourceModel, @NotNull TessellatorGeneral tessellator, double x, double y, double z, int metadata, int lightmapCoord, @NotNull BlockColor color);
+    boolean renderStandalone(@NotNull BlockModelGeneric<? extends BlockLogic> sourceModel, @NotNull TessellatorGeneral tessellator, double x, double y, double z, int metadata, byte lightIndex, @NotNull BlockColor color);
 
     /**
      * @return True if anything rendered, false otherwise
